@Echo off
SETLOCAL EnableDelayedExpansion

Set "__Alisha_KDK=Keal's DevKit"

Echo === Welcome to !__Alisha_KDK! ===

Call :__Zoey_Path_Entry
Call :__Zoey_Root_Entry

Call :__Zoey_Project_Entry !__Alisha_Path_[Count]!
Call :__Zoey_Version_Entry !__Alisha_Path_[Count]!

Echo Project: "!__Alisha_Project!"
Echo Version: "!__Alisha_Version!"
Echo Root: "!__Alisha_Path_[Root]!"

Rem :: Call ".\!__Alisha_KDK!\!__Alisha_KDK! Compile.cmd"

Exit /B 0

:__Zoey_Path_Entry
	
	Set "__Alisha_Path_Buffer=%~dp0"
	
	If "!__Alisha_Path_[Count]!"=="" (
		Set /A "__Alisha_Path_[Count]=0"
	)
	
	Call :__Zoey_Path_Loop
		
	Exit /B
	
:__Zoey_Path_Loop
		
	Set /A "__Alisha_Path_Counter=0"
	
	Set "__Alisha_Path_Char=!__Alisha_Path_Buffer:~0,1!"
	Set "__Alisha_Path_Buffer=!__Alisha_Path_Buffer:~1!"
	
	If "__Alisha_Path_[!__Alisha_Path_[Count]!][Length]"=="" (
		Set /A "__Alisha_Path_[!__Alisha_Path_[Count]!][Length]=0"
	)
	
	If "!__Alisha_Path_Char!"=="" (
		Exit /B
	)

	If "!__Alisha_Path_Buffer!"=="" (
		Echo %__Alisha_Path_[Count]% is ^"!__Alisha_Path_[%__Alisha_Path_[Count]%]!^" ^( !__Alisha_Path_[%__Alisha_Path_[Count]%][Length]! ^)
		Exit /B
	)
	
	If "!__Alisha_Path_Char!"=="\" (
		Set /A "__Alisha_Path_Counter+=1"
	) Else If "!__Alisha_Path_Char!"=="/" (
		Set /A "__Alisha_Path_Counter+=1"
	)			
	
	If !__Alisha_Path_Counter! GTR 0 (
		
		Echo %__Alisha_Path_[Count]% is ^"!__Alisha_Path_[%__Alisha_Path_[Count]%]!^" ^( !__Alisha_Path_[%__Alisha_Path_[Count]%][Length]! ^)
		
		Set /A "__Alisha_Path_[Count]+=1"
		
	) Else (
		
		Set /A "__Alisha_Path_[!__Alisha_Path_[Count]!][Length]+=1"
		Set "__Alisha_Path_[!__Alisha_Path_[Count]!]=!__Alisha_Path_[%__Alisha_Path_[Count]%]!!__Alisha_Path_Char!"
		
	)
		
	Goto :__Zoey_Path_Loop

:__Zoey_Version_Entry
	
	Set "__Alisha_Version=!__Alisha_Path_[%1]!
	Call :__Zoey_Version_Loop_1
	Exit /B
	
:__Zoey_Version_Loop_1
	
	Rem Echo Loop 1: !__Alisha_Version!
	
	If "!__Alisha_Version:~-1!"=="" (
		Exit /B
	)

	If "!__Alisha_Version:~-1!"==")" (
		Set "__Alisha_Version=!__Alisha_Version:~0,-1!"
		Call :__Zoey_Version_Loop_2
	) Else (
		Set "__Alisha_Version=!__Alisha_Version:~0,-1!"
		Goto :__Zoey_Version_Loop_1
	)
		
	Exit /B
	
:__Zoey_Version_Loop_2

	Rem Echo Loop 2: !__Alisha_Version!
	
	If "!__Alisha_Version:~0,1!"=="" (
		Exit /B
	)

	If "!__Alisha_Version:~0,1!"=="(" (
		Set "__Alisha_Version=!__Alisha_Version:~1!"
		Exit /B
	) Else (
		Set "__Alisha_Version=!__Alisha_Version:~1!"
		Goto :__Zoey_Version_Loop_2
	)
	
	Exit /B

:__Zoey_Project_Entry
	
	Set "__Alisha_Project=!__Alisha_Path_[%1]!
	Call :__Zoey_Project_Loop_1
	Exit /B
	
:__Zoey_Project_Loop_1
	
	Rem Echo Loop 1: !__Alisha_Project!
	
	If "!__Alisha_Project:~-1!"=="" (
		Exit /B
	)

	If "!__Alisha_Project:~-1!"=="(" (
		Set "__Alisha_Project=!__Alisha_Project:~0,-1!"
		Call :__Zoey_Project_Loop_2
	) Else (
		Set "__Alisha_Project=!__Alisha_Project:~0,-1!"
		Goto :__Zoey_Project_Loop_1
	)
		
	Exit /B
	
:__Zoey_Project_Loop_2

	Rem Echo Loop 2: !__Alisha_Project!
	
	If "!__Alisha_Project:~-1!"=="" (
		Exit /B
	)

	If "!__Alisha_Project:~-1!"==" " (
		Set "__Alisha_Project=!__Alisha_Project:~0,-1!"
		Exit /B
	) Else (
		Set "__Alisha_Project=!__Alisha_Project:~0,-1!"
		Goto :__Zoey_Project_Loop_2
	)
	
	Exit /B

:__Zoey_Root_Entry

	Set "__Alisha_Path_[Root]="
	Set /A "__Alisha_Path_[Index]=0"

	Set "__Alisha_Path_[Root]=!__Alisha_Path_[%__Alisha_Path_[Index]%]!"
	Set /A "__Alisha_Path_[Index]+=1"
	
	Call :__Zoey_Root_Loop
	
	Exit /B

:__Zoey_Root_Loop

	If !__Alisha_Path_[Index]! EQU !__Alisha_Path_[Count]! (
		Set /A "__Alisha_Path_[Index]-=1"
		If !__Alisha_Path_[Index]! GTR 0 (
			Set "__Alisha_Path_[Root]=!__Alisha_Path_[Root]!\"
		)
		Exit /B
	) Else (
		Set "__Alisha_Path_[Root]=!__Alisha_Path_[Root]!\!__Alisha_Path_[%__Alisha_Path_[Index]%]!"
		Set /A "__Alisha_Path_[Index]+=1"
	)
	
	Goto :__Zoey_Root_Loop
